 ;+
;NAME:
; thm_ui_set_tlimits
;PURPOSE:
; A widget interface for setting time ranges for the thm_gui widget
;CALLING SEQUENCE:
; thm_ui_set_tlimits, master_widget_id
;INPUT:
; master_widget_id = the id number of the widget that calls this
;OUTPUT:
; none, the start and end time are set
;HISTORY:
; 9-may-2007, jmm, jimm@ssl.berkeley.edu
;$LastChangedBy:$
;$LastChangedDate:$
;$LastChangedRevision:$
;$URL:$
;
;-
Pro thm_ui_set_tlimits_event, event

  Common tlimits_saved, t0_sav, t1_sav, t0_init, t1_init
  Common saved_time_sel, time_selected
;start here
  widget_control, event.id, get_uval = uval
  Case uval Of
    'EXIT': Begin
      widget_control, event.top, get_uval = state, /no_copy      
      thm_ui_update_progress, state.gui_id, 'End Choosing time range'
      widget_control, event.top, set_uval = state, /no_copy      
      widget_control, event.top, /destroy
    End
    'STTIME':Begin
      time_selected = -1
      thm_ui_tselect
      t0 = time_selected
      If(is_struct(t0)) Then Begin
        t0_sav = time_double(t0)
;history
        h = 'tlimit, '+''''+time_string(t0_sav)+''''+', '+ $
          ''''+time_string(t1_sav)+''''
        widget_control, event.top, get_uval = state, /no_copy
        thm_ui_update_history, state.gui_id, h
        tlimit, t0_sav, t1_sav
;Set time in display
        widget_control, state.sttime_display, set_val = time_string(t0_sav)
        widget_control, event.top, set_uval = state, /no_copy
      Endif Else Begin
        message, 'Bad time selection, No action taken'
      Endelse
    End
    'ENTIME':Begin
      time_selected = -1
      thm_ui_tselect
      t1 = time_selected
      If(is_struct(t1)) Then Begin
        t1_sav = time_double(t1)
        h = 'tlimit, '+''''+time_string(t0_sav)+''''+', '+ $
          ''''+time_string(t1_sav)+''''
        widget_control, event.top, get_uval = state, /no_copy
        thm_ui_update_history, state.gui_id, h
        tlimit, t0_sav, t1_sav
        widget_control, state.entime_display, set_val = time_string(t1_sav)
        widget_control, event.top, set_uval = state, /no_copy
      Endif Else Begin
        message, 'Bad time selection, No action taken'
      Endelse
    End
    'STTIME_DISPLAY':Begin
      widget_control, event.id, get_val = temp_string
      t0 = time_string(temp_string)
      If(event.type Le 2) Then Begin
        If(is_string(t0)) Then Begin
          t0_sav = time_double(t0)
          h = 'tlimit, '+''''+time_string(t0_sav)+''''+', '+ $
            ''''+time_string(t1_sav)+''''
          widget_control, event.top, get_uval = state, /no_copy
          thm_ui_update_history, state.gui_id, h
          tlimit, t0_sav, t1_sav
          widget_control, state.sttime_display, set_val = time_string(t0_sav)
          widget_control, event.top, set_uval = state, /no_copy
        Endif Else Begin
          message, 'Bad time selection, No action taken'
        Endelse
      Endif
    End
    'ENTIME_DISPLAY':Begin
      widget_control, event.id, get_val = temp_string
      t1 = time_string(temp_string)
      If(event.type Le 2) Then Begin
        If(is_string(t1)) Then Begin
          t1_sav = time_double(t1)
          h = 'tlimit, '+''''+time_string(t0_sav)+''''+', '+ $
            ''''+time_string(t1_sav)+''''
          widget_control, event.top, get_uval = state, /no_copy
          thm_ui_update_history, state.gui_id, h
          tlimit, t0_sav, t1_sav
          widget_control, state.entime_display, set_val = time_string(t1_sav)
          widget_control, event.top, set_uval = state, /no_copy
        Endif Else Begin
          message, 'Bad time selection, No action taken'
        Endelse
      Endif
    End
    'TLIMIT':Begin
      ctime, trange_new, npoints = 2
      t0_sav = trange_new[0] & t1_sav = trange_new[1]
      h = 'tlimit, '+''''+time_string(t0_sav)+''''+', '+ $
        ''''+time_string(t1_sav)+''''
      widget_control, event.top, get_uval = state, /no_copy
      thm_ui_update_history, state.gui_id, h
      tlimit, t0_sav, t1_sav
      widget_control, state.sttime_display, set_val = time_string(t0_sav)
      widget_control, state.entime_display, set_val = time_string(t1_sav)
      widget_control, event.top, set_uval = state, /no_copy
    End
    'RESET_TLIMIT':Begin
      h = 'tlimit, '+''''+time_string(t0_init)+''''+', '+ $
        ''''+time_string(t1_init)+''''
      widget_control, event.top, get_uval = state, /no_copy
      thm_ui_update_history, state.gui_id, h
      tlimit, t0_init, t1_init
      widget_control, state.sttime_display, set_val = time_string(t0_init)
      widget_control, state.entime_display, set_val = time_string(t1_init)
      widget_control, event.top, set_uval = state, /no_copy
    End
  Endcase
End

Pro thm_ui_set_tlimits, proc_id

  Common tlimits_saved, t0_sav, t1_sav, t0_init, t1_init

;time selection widget
  timesel = widget_base(/col, /align_center, /tlb_frame_attr, $
                        title = 'Time Selection Widget')
  timebase = widget_base(timesel, /row, /align_left, $
                        title = 'Time Selection Widget')
  timeselbase = widget_base(timebase, /column, /align_left, frame = 5)

; sttime button
  sttime_button = widget_base(timeselbase, /col, /align_left)
  sttimebut = widget_button(sttime_button, val = ' Choose Start time ', $
                            uval = 'STTIME', /align_left)
; entime button
  entime_button = widget_base(timeselbase, /col, /align_left)
  entimebut = widget_button(entime_button, val = ' Choose End time ', $
                            uval = 'ENTIME', /align_left)
;time display widget
  timedisplaybase = widget_base(timebase, /column, /align_left, frame = 5)
;set init values, if they don't exist
  widget_control, proc_id, get_uval = astate, /no_copy
  widget_control, astate.cw, get_uval = wstate, /no_copy
  gui_id = astate.cw
  If(n_elements(t0_sav) Eq 0 Or n_elements(t1_sav) Eq 0) Then Begin
     t0_sav = wstate.st_time & t1_sav = wstate.en_time
  Endif
  If(n_elements(t0_init) Eq 0 Or n_elements(t1_init) Eq 0) Then Begin
     t0_init = wstate.st_time & t1_init = wstate.en_time
  Endif
  widget_control, astate.cw, set_uval = wstate, /no_copy
  widget_control, proc_id, set_uval = astate, /no_copy

; sttime text
  sttime_display = widget_text(timedisplaybase, /edit, $
                               uval = 'STTIME_DISPLAY', $
                               val = time_string(t0_sav), $
                               xsize = 30, /all_events)
; entime button
  entime_display = widget_text(timedisplaybase, /edit, $
                               uval = 'ENTIME_DISPLAY', $
                               val = time_string(t1_sav), $
                               xsize = 30, /all_events)
;tlimit button
  tlimitbut = widget_button(timebase, val = ' Tlimits from Cursor ', $
                            uval = 'TLIMIT', /align_center)
;tlimit reset button
  tlimitresetbut = widget_button(timebase, val = ' Reset to Init value ', $
                            uval = 'RESET_TLIMIT', /align_center)
;exit button
  exitbut = widget_button(timesel, val = ' Accept and Close ', $
                          uval = 'EXIT', /align_center)

  state = {proc_id:proc_id, $
           gui_id:gui_id, $
           sttime_display:sttime_display, $
           entime_display:entime_display}

  widget_control, timesel, set_uval = state, /no_copy
  widget_control, timesel, /realize
  xmanager, 'thm_ui_set_tlimits', timesel, /no_block

  Return
End


