; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

  PRO scm_cowave_read_seque, unit,Jul,iday,imon,iyear, $
                             ih1,im1,is1,ims1,imm1, datiso1, $
                        iano, nbp,titpan,dtpan,ncpan,nbppan,dataulf,nbpt

; ----------------------------------------------------------------------
; proc scm_cowave_read_seque : lecture d'une sequence de cowave.resu
;                              dataulf(3,nbpt)
;
; P. Robert, CETP, Septembre 2000, revu Janvier/Mars 2001
;                                  revu sepr 2002 pour seq incomplete
;                                  revu apr  2007 pour imposer nbpan=1
; ----------------------------------------------------------------------

 
; mise a zero de tous les parametres

  titpan= ' '
  dtpan=  0. 
  ncpan=  0  
  nbppan= 0L 

; *** on suppose que tous les pannels ont 3 courbes de nbp points

  dataulf= REPLICATE(0.,3,nbp)

  bid   =' '
  tstart=' '
  ttrait=' '
  texte =' '
  datiso1=' '

  nbpt=0L

; lecture d'une sequence
; ======================

  IF(EOF(unit)) THEN BEGIN
             PRINT, 'EOF of cowave.resu has already been encontered'
             RETURN
             ENDIF

  READF, unit, ttrait
  PRINT, ttrait

  IF(ttrait EQ 'END OF FILE') THEN BEGIN
                             PRINT, 'EOF REACHED on cowave.resu file'
                             PRINT, 'No more sequency, data set to zero'
                             RETURN
                             ENDIF
  READF, unit, tstart
  READF, unit, bid
  READF, unit, Jul,iday,imon,iyear
  READF, unit, bid
  READF, unit, FORMAT='(3i3,2i4,2x,a)', ih1,im1,is1,ims1,imm1,datiso1
  READF, unit, bid
  READF, unit, iano

  PRINT, tstart
  PRINT, 'date:', Jul,iday,imon,iyear,iano
  PRINT, 'Time:', ih1,im1,is1,ims1, imm1

; ----------------------

  READF, unit, ttrait
  READF, unit, tstart
  READF, unit, bid
  READF, unit, istep
  READF, unit, bid
  READF, unit, FORMAT='(a)', texte
  READF, unit, bid
  READF, unit, dt
  READF, unit, bid
  READF, unit, nc
  READF, unit, bid
  READF, unit, nbpt

  titpan=texte
  dtpan=dt
  ncpan=nc
  nbppan=nbpt

  PRINT, tstart
  PRINT, titpan
; PRINT, 'dt,ncp,nbp=',dtpan,ncpan,nbppan

; *** on a suppose que toutes les courbes de chaque pannel avait nbp pts

  IF(nbpt NE nbp) THEN BEGIN
      PRINT, '*** NBPT(=',nbpt,') NE NBP (=',nbp,')'
      PRINT, '    Reading impossible, aborted !'
      PRINT, '*** an IDL EXIT is suggered'
      PRINTF,-2,'R_SEQ_COWAVE :ERR-NBPT NE NBP                     /***'
                  EXIT
                  ENDIF

; *** on a suppose que tous les pannels avait 3 courbes

  IF(ncpan NE 3) THEN BEGIN
      PRINT, '*** NCPAN=',ncpan,' SHOULD BE 3'
      PRINT, '*** an IDL EXIT is suggered'
      PRINTF,-1,'R_SEQ_COWAVE :ERR-NCPAN SHOULD BE 3         /***'
                       EXIT
                       ENDIF

  READF, unit, bid
  READF, unit, dataulf
  READF, unit, bid

  RETURN
  END

; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
