; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

  PRO scm_get_spin_data, satname, time_state, val_spinpha,val_spinper, $
                         val_spinras,val_spindec

; ----------------------------------------------------------------------
; Get arrays of spin_phase, spin_period, spin_direction from STAT file
;     (time resolution = 30 sec)
; P. Robert & O. Le Contel, CETP, March 2006
; ----------------------------------------------------------------------

  PRINT, '------------------------------'
  PRINT, 'Begin scm_get_spin_data'
  PRINT, 'Get spin data from STAT file..'
  PRINT

  thm_load_state, probe=satname, /get_support_data

  spinphase = 'th'+satname+'_state_spinphase'
  spinper   = 'th'+satname+'_state_spinper'
  spinras   = 'th'+satname+'_state_spinras'
  spindec   = 'th'+satname+'_state_spindec'

  get_data, spinphase, time_state, val_spinpha
  get_data, spinper ,  time_state, val_spinper
  get_data, spinras ,  time_state, val_spinras
  get_data, spindec ,  time_state, val_spindec

  PRINT, 'Number of points             :', N_elements(time_state)
  PRINT, 'Time resolution (theor. 30 s):', time_state(1)-time_state(0)
  PRINT, 'End of scm_get_spin_data'
  PRINT, '------------------------'

  END

; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
