; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

  PRO scm_read_cowave, times, Bx,By,Bz, Nbwin,SCname,SCnum,Nbp, $
                       Fsamp,Fspin,Fdet,Fcut, Fmin,Fmax, Step,mode, $
                       title,subtitle,anomaly

;-----------------------------------------------------------------------
; Read the cowave.resu file and store data into arguments
;
; Patrick Robert, CETP, February 2007
;-----------------------------------------------------------------------

  PRINT, ' '
  PRINT, 'Reading cowave.resu, please wait...'

  GET_LUN, unit
  OPENR, unit, 'cowave.resu'

  scm_cowave_read_head, unit,fultit,projet,experi,SCname,SCnum,fnat, $
                        Nbp, Fdet,nlis,Fcut,Fmin,Fmax,Nbwin, $
                        bitr,Fsamp,Fspin,srasc,sdec
; title=fultit
  
; for each window, we get time and B field

  times=DBLARR(Nbwin,Nbp)
  Bx=   FLTARR(Nbwin,Nbp)
  By=   FLTARR(Nbwin,Nbp)
  Bz=   FLTARR(Nbwin,Nbp)

  print, 'Fsamp=',Fsamp

  FOR iseq=1,Nbwin DO BEGIN
  scm_cowave_read_seque, unit,Jul,iday,imon,iyear,ih1,im1,is1, $
                         ims1,imic1, datiso1,iano,$
                         nbp,titpan,dtpan,ncpan,nbppan,dataulf,nbpt

  IF(EOF(unit)) THEN BEGIN 
                Nbwin2= iseq-1
                PRINT, 'scm_cowave_read_seque : WARNING, ', $
                       'the cowave.resu file should contains ',Nbwin, $
                       ' sequencies, but here only ', Nbwin2, $
                        FORMAT='(2a,i5,a,i5)'
                PRINT, '                      : ', $
                       'This new value is now set'
                Nbwin= Nbwin2

;               resize array data to new Nbwin

                times=times(0:Nbwin-1)
                Bx= Bx(0:Nbwin-1,*)
                By= By(0:Nbwin-1,*)
                Bz= Bz(0:Nbwin-1,*)

                BREAK
                ENDIF ELSE BEGIN

                subtitle=titpan
                Tzero= tu_isodate_to_julsec(datiso1, secofday)
                print, format='(a,f25.13)',' T0=',Tzero
              
                times(iseq-1,*)=Tzero+double(Findgen(nbp))/double(Fsamp)
                
                Bx(iseq-1,*)= dataulf(0,*)
                By(iseq-1,*)= dataulf(1,*)
                Bz(iseq-1,*)= dataulf(2,*)

                ENDELSE

  ENDFOR

; reading string EOF for normal termination

  IF(EOF(unit)) THEN PRINT, '                      : Reading stopped'$
                ELSE scm_cowave_read_eof, unit

  PRINT, 'unit ',unit,' now free.', FORMAT='(a,i4,a)'
  FREE_LUN, unit
  PRINT, 'Reading cowave.resu done...'
  PRINT, '---------------------------'


  END
;
; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
