; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

  PRO scm_reduce_period_S4, le1,le2,le3,le4,time,val1,val2,val3,val4,t1,t2

; ----------------------------------------------------------------------
; reduce the dimension of the time array and 4 Scalar valu arrays 
; to keep only values between t1 & t2
; if there is no values into time period, the closest values are keeped.
; This routine is the same procedure than scm_reduce_period, but with
; 4 data values, with the same data time values.
;
; P. Robert, CETP, april 2007
; ----------------------------------------------------------------------


  n= N_ELEMENTS(time)

  PRINT, '-----------------------------------'
  PRINT,  le1+'/'+le2+'/'+le3+'/'+le4, ' reduction :'
  PRINT, 'Input time dimension array        = ',n

  isobeg=tu_julsec_to_isodate(time(0),7)
  isoend=tu_julsec_to_isodate(time(n-1),7)

  PRINT, 'Begin and end of data time  array = ', isobeg, '  ', isoend

  isodate1=tu_julsec_to_isodate(t1,7)
  isodate2=tu_julsec_to_isodate(t2,7)

  PRINT, 'Selected time interval T1, T2     = ', isodate1, '  ',isodate2

  IF(n LT 2) THEN BEGIN
    PRINT, '-----------------------------------------------------------'
    PRINT, '*** scm_reduce_time_period: array dimension= ',n,' < 2'
    PRINT, '*** Nothing is done'
    PRINT, '*** an IDL EXIT is suggered'
    PRINT, '-----------------------------------------------------------'
    EXIT
    ENDIF

  ibeg= -1L
  iend= -1L

  FOR i=1L,n-1L  DO BEGIN
  IF ((time(i) GT t1) AND (ibeg EQ -1L)) THEN ibeg= i-1L
  IF ((time(i) GT t2) AND (iend EQ -1L)) THEN iend= i
  ENDFOR

  IF (ibeg GE 0 AND iend EQ -1) THEN iend=n-1L

  PRINT, 'New dimension range               = ', ibeg,iend
  PRINT, 'So reduction will be from           ',n,' to ',iend-ibeg+1

  IF((iend-ibeg) LT 1L) THEN BEGIN
    PRINT, '-----------------------------------------------------------'
    PRINT, '*** scm_reduce_time_period: reducing need at least 2 points'
    PRINT, '*** abnormal value for time selection, nothing is done'
    PRINT, '*** an IDL EXIT is suggered'
    PRINT, '-----------------------------------------------------------'
    EXIT
    ENDIF

; reducing arrays

  count=-1L
  FOR i= ibeg, iend DO BEGIN
  count=count+1L
  time(count)=time(i)
  val1(count)=val1(i)
  val2(count)=val2(i)
  val3(count)=val3(i)
  val4(count)=val4(i)
  ENDFOR

; resize to the usefull lenfth

  time=time(0:count)
  val1=val1(0:count)
  val2=val2(0:count)
  val3=val3(0:count)
  val4=val4(0:count)

  nt=N_ELEMENTS(time)
  nv=N_ELEMENTS(val1)

  IF ((nt EQ 0) OR (nv EQ 0)) THEN BEGIN
    PRINT, '-----------------------------------------------------------'
    PRINT, '*** scm_reduce_time_period: selection give 0 elements'
    PRINT, '*** nt,nv,iend+1          =',nt,nv,iend+1
    PRINT, '*** new arrays are empty'
    PRINT, '*** an IDL EXIT is suggered'
    PRINT, '-----------------------------------------------------------'
    EXIT
    ENDIF

  ndim= iend+1 -ibeg

  IF ((nt NE nv) OR (nt NE ndim)) THEN BEGIN
    PRINT, '-----------------------------------------------------------'
    PRINT, '*** scm_reduce_time_period: selection done  not expected'
    PRINT, '*** nt,nv,ndim            =',nt,nv,ndim
    PRINT, '*** new arrays are empty'
    PRINT, '*** an IDL EXIT is suggered'
    PRINT, '-----------------------------------------------------------'
    EXIT
    ENDIF

  isot1=tu_julsec_to_isodate(time(0),7)
  isot2=tu_julsec_to_isodate(time(nt-1),7)

  PRINT, 'Begin and end of new  time  array = ', isot1, ' ', isot2
  PRINT, 'Begin and end of new value  array = ', $
                  le1,val1(0), val1(nv-1), $
                  le2,val2(0), val2(nv-1), $
                  le3,val3(0), val3(nv-1), $
                  le4,val4(0), val4(nv-1), $
                  FORMAT='(a,t40,a,2f22.8,3(/,t40,a,2f22.8))
  PRINT, '-----------------------------------'

  END

; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
