function thm_sst_ser,time,index=index,probe=probe,times=times

data_cache,'th'+probe+'_sst_raw_data',data,/get

if not keyword_set(data) then begin
   dprint,dlevel=0,'No data loaded for ',probe
   return,0
endif

if keyword_set(times) then return, *data.sef_001_time

dptr = data.ser_001_data
dim = size(/dimension,*dptr)
dist = thm_sst_dist3d_16x64()
dist.magf = !values.f_nan

if not keyword_set(index) then $
    index=round( interp(dindgen(dim[0]),*data.ser_001_time,time) )

dprint,dlevel=3,index

dist.index = index
dist.time = (*data.ser_001_time)[index]
dist.end_time = dist.time+3
dist.data= thm_part_decomp16((*data.ser_001_data)[index,*,*])
dist.valid=1
dist.mass = 0.511e6/(2.9979e5)^2


return,dist
end