function thm_sst_sif,time,index=index,probe=probe,times=times


data_cache,'th'+probe+'_sst_raw_data',data,/get

if not keyword_set(data) then begin
   dprint,dlevel=0,'No data loaded for ',probe
   return,0
endif

if keyword_set(times) then return, *data.sif_064_time

dptr = data.sif_064_data
dim = size(/dimension,*dptr)
dist = thm_sst_dist3d_16x64()
dist.magf = !values.f_nan

if n_elements(index) eq 0 then $
    index=round( interp(dindgen(dim[0]),*data.sif_064_time,time) )

dprint,dlevel=5,index

dist.index = index
dist.time = (*data.sif_064_time)[index]
dist.end_time = dist.time+3
dist.data= thm_part_decomp16((*data.sif_064_data)[index,*,*])
dist.units_name = 'Counts'
dist.valid=1
dist.mass = 1836.*0.511e6/(2.9979e5)^2

return,dist
end